> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Reverse an invoice

PUT https://rest.test.zuora.com/v1/invoices/{invoiceKey}/reverse
Content-Type: application/json

**Note:** This operation is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.

Reverses a posted invoice. The reversal operation is performed asynchronously when the invoice contains more than 2,000 items in total.  

 If the specified invoice was created through invoice splitting, reversing that  invoice also reverses all split invoices that were generated from the same original invoice.  The original parent invoice remains in `Split` status and is not reversed. 

**Restrictions**

You are not allowed to reverse an invoice if any of the following restrictions is met:
* Payments and credit memos are applied to the invoice.
* The invoice is split.
* The invoice is not in Posted status.
* The total amount of the invoice is less than 0 (a negative invoice).
* Using Tax Connector for Extension Platform to calculate taxes.
* An invoice contains more than 50,000 items in total, including invoice items, discount items, and taxation items.

See [Invoice Reversal](https://knowledgecenter.zuora.com/CB_Billing/IA_Invoices/Reverse_Posted_Invoices) for more information.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/invoices/put-reverse-invoice

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `invoiceKey` (string, required) — The ID or number of the invoice. For example, 2c92c8955bd63cc1015bd7c151af02ab or INV-0000001.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a PutReverseInvoiceType.

- `applyEffectiveDate` (date, optional) — The date when the credit memo is applied to the invoice that will be reversed, in `yyyy-mm-dd` format. The effective date must be later than or equal to the memo date. The default value is the date when you reverse the invoice and create the credit memo. **Note:** If the target invoice is a split invoice, this date must be equal to or later than all invoice dates in the split invoice group.
- `comment` (string, optional) — Comments about the reversal. The comment is used as the comment of the credit memo generated by reversing the specified invoice.
- `memoDate` (date, optional) — The date when the credit memo was created, in `yyyy-mm-dd` format. The memo date must be later than or equal to the invoice date. The default value is the date when you reverse the invoice and create the credit memo. **Note:** If the target invoice is a split invoice, this date must be equal to or later than all invoice dates in the split invoice group.
- `reasonCode` (string, optional) — A code identifying the reason for the reversal. The value must be an existing reason code or empty. The code is used as the reason code of the credit memo generated by reversing the specified invoice. If you do not specify a value, Zuora uses the default reason code `Invoice reversal` for the credit memo.

## Response

### 200

OK

- `creditMemo` (PutReverseInvoiceResponseTypeCreditMemo, optional) — Container for the credit memo that is automatically generated during the invoice reversal.
- `creditMemos` (list of ReverseInvoiceResponseCreditMemo, optional) — Array of credit memo objects generated by the reversal. This field can contain multiple items when the target invoice belongs to a split invoice group.
- `debitMemo` (PutReverseInvoiceResponseTypeDebitMemo, optional) — Container for the debit memo that is automatically generated during the reversal of the credit memo related to this invoice. If no related credit memo is reversed, this field is not returned in the response body.
- `id` (string, optional, nullable) — The ID of the invoice to be reversed. This field is available only when the reversal operation is performed asynchronously.
- `jobId` (string, optional, nullable) — The ID of the job that handles the invoice reversal operation. You can specify the value of this field as the value of the `jobId` path parameter in the [Retrieve an operation job](https://developer.zuora.com/v1-api-reference/api/operation/GET_OperationJob/) API operation to query job information. This field is available only when the reversal operation is performed asynchronously.
- `jobStatus` (enum, optional, nullable) — The status of the invoice reversal operation. This field is available only when the reversal operation is performed asynchronously.
  - Allowed values: `Pending`, `Processing`, `Failed`, `Completed`
- `success` (boolean, optional) — Returns `true` if the request was processed successfully.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### PutReverseInvoiceResponseTypeCreditMemo

Container for the credit memo that is automatically generated during the invoice reversal.

- `id` (string, optional) — The ID of the credit memo.

### ReverseInvoiceResponseCreditMemo

- `id` (string, optional) — The ID of the credit memo.

### PutReverseInvoiceResponseTypeDebitMemo

Container for the debit memo that is automatically generated during the reversal of the credit memo related to this invoice. If no related credit memo is reversed, this field is not returned in the response body.

- `id` (string, optional) — The ID of the debit memo.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "applyEffectiveDate": "2017-02-20",
  "memoDate": "2017-02-20"
}
```

**Response**

```json
{
  "creditMemo": {
    "id": "402890555a40ca7f015a5b099b0e307a"
  },
  "success": true
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/invoices/invoiceKey/reverse"

payload = {
    "applyEffectiveDate": "2017-02-20",
    "memoDate": "2017-02-20"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/invoices/invoiceKey/reverse';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"applyEffectiveDate":"2017-02-20","memoDate":"2017-02-20"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/invoices/invoiceKey/reverse"

	payload := strings.NewReader("{\n  \"applyEffectiveDate\": \"2017-02-20\",\n  \"memoDate\": \"2017-02-20\"\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/invoices/invoiceKey/reverse")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"applyEffectiveDate\": \"2017-02-20\",\n  \"memoDate\": \"2017-02-20\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://rest.test.zuora.com/v1/invoices/invoiceKey/reverse")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"applyEffectiveDate\": \"2017-02-20\",\n  \"memoDate\": \"2017-02-20\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://rest.test.zuora.com/v1/invoices/invoiceKey/reverse', [
  'body' => '{
  "applyEffectiveDate": "2017-02-20",
  "memoDate": "2017-02-20"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/invoices/invoiceKey/reverse");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"applyEffectiveDate\": \"2017-02-20\",\n  \"memoDate\": \"2017-02-20\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "applyEffectiveDate": "2017-02-20",
  "memoDate": "2017-02-20"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/invoices/invoiceKey/reverse")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```